package CollectionGenericObjects;

import java.lang.reflect.Array;

public class MassiveGenericObjects<T> implements ICollectionGenericObjects<T>{
    private T[] _collection;
    @Override
    public void SetMaxCount(int value, Class<T> type) {
        if (value > 0) {
            _collection = (T[]) Array.newInstance(type, value);
        }
    }
    @Override
    public int Count() {
        return _collection.length;
    }
    @Override
    public int Insert(T obj) {
        for (int i = 0; i < Count(); i++)
        {
            if (_collection[i] == null)
            {
                _collection[i] = obj;
                return i;
            }
        }
        return -1;
    }
    @Override
    public int Insert(T obj, int position) {
        if (position >= Count() || position < 0) return -1;
        if (_collection[position] == null)
        {
            _collection[position] = obj;
            return position;
        }
        int temp = position + 1;
        while(temp < Count())
        {
            if (_collection[temp] == null)
            {
                _collection[temp] = obj;
                return temp;
            }
            ++temp;
        }
        temp = position - 1;
        while(temp >= 0)
        {
            if (_collection[temp] == null)
            {
                _collection[temp] = obj;
                return temp;
            }
            --temp;
        }
        return -1;
    }
    @Override
    public T Remove(int position) {
        if (position >= Count() || position < 0) return null;
        T myObject = (T) _collection[position];
        _collection[position] = null;
        return myObject;
    }
    @Override
    public T Get(int position) {
        if (position < 0 || position >= Count()) return null;
        return (T) _collection[position];
    }
}
