import CollectionGenericObjects.AbstractCompany;
import CollectionGenericObjects.AdditionalCollection;
import Drawnings.*;
import Entities.EntityCleaningCar;
import Entities.EntityTruck;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;

public class FormAdditionalCollection extends JFrame {
    private DrawningTruck _drawningTruck;
    private IDrawningWheels _wheels;
    private AbstractCompany _company;
    private JPanel defaultPanel;
    private JButton buttonCreate;
    private JList<String> listEntity;
    private JList<String> listWheels;
    private JPanel pictureBox;
    private AdditionalCollection<EntityTruck, IDrawningWheels> additionalCollection;

    public FormAdditionalCollection() {
        setTitle("Создать форму, где использовался бы экземпляр от описанного выше " +
                "параметризованного класса и выдавал сгенерированные экземпляры " +
                "класса прорисовки с выводом результата на форму");
        setLocation(200, 100);
        pack();
        setVisible(true);
        add(defaultPanel);
        setSize(600, 400);

        additionalCollection = new AdditionalCollection<>(3, (Class) EntityTruck.class, (Class) IDrawningWheels.class);
        Random random = new Random();
        addEntities(random);
        addWheels(random);
        buttonCreate.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                _drawningTruck = additionalCollection.CreateFromAdditionalCollection();
                _drawningTruck.SetPictureSize(pictureBox.getWidth(), pictureBox.getHeight());
                _drawningTruck.SetPosition(90, 90);
                repaint();
                DrawningTruck truck;
                repaint();
                if (_drawningTruck instanceof DrawningCleaningCar)
                    truck =  new DrawningCleaningCar((EntityCleaningCar) _drawningTruck.getEntityTruck(), _drawningTruck.drawningWheels);
                else
                    truck =  new DrawningTruck(_drawningTruck.getEntityTruck(), _drawningTruck.drawningWheels);
                _company._collection.Insert(truck);
                FormCleaningCarCollection.Show();

                String[] data1 = new String[additionalCollection.GetCountEntities()];
                for (int i = 0; i < additionalCollection.GetCountEntities(); i++) {
                    EntityTruck entity = additionalCollection._collectionEntity[i];
                    data1[i] = ToString(entity);
                }
                String[] data2 = new String[additionalCollection.GetCountWheels()];
                for (int i = 0; i < additionalCollection.GetCountWheels(); i++) {
                    IDrawningWheels wheels = additionalCollection._collectionWheels[i];
                    data2[i] = ToString(wheels);
                }
                listEntity.setListData(data1);
                listWheels.setListData(data2);
            }
        });
    }
    private String ToString(EntityTruck entity) {
        String str = "";
        if (entity instanceof EntityCleaningCar) str += "EntityCleaningCar ";
        else str += "EntityTruck ";
        str += entity.getBodyColor().toString();
        return str;
    }
    private String ToString(IDrawningWheels wheels) {
        if (wheels == null || wheels.getNumberOfWheels() == null)
            return "Dont have wheels";
        String str = "Wheel ";
        if (wheels instanceof DrawningCircleWheels) str += "Circle ";
        else if (wheels instanceof DrawningRhombWheels) str += "Rhomb ";
        else str += "Triangle ";
        str += wheels.getNumberOfWheels().toString();
        return str;
    }
    private void addEntities(Random rnd) {
        for (int i = 0; i < additionalCollection.GetCountEntities(); i++) {
            EntityTruck entityTruck;
            if (rnd.nextBoolean()) {
                entityTruck = new EntityTruck(rnd.nextInt(100, 300), rnd.nextInt(1000, 3000),
                        new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)));
            }
            else {
                entityTruck = new EntityCleaningCar(rnd.nextInt(100, 300), rnd.nextInt(1000, 3000),
                        new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)),
                        new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)),
                        rnd.nextBoolean(), rnd.nextBoolean(), rnd.nextBoolean());
            }
            additionalCollection.Insert(entityTruck);
        }
    }
    private void addWheels(Random rnd) {
        for (int i = 0; i < additionalCollection.GetCountWheels(); i++) {
            int countWheels;
            switch (countWheels = rnd.nextInt(1, 4)) {
                case 1:
                    _wheels = new DrawningCircleWheels();
                    break;
                case 2:
                    _wheels = new DrawningRhombWheels();
                    break;
                case 3:
                    _wheels = new DrawningTriangleWheels();
                    break;
                default:
                    _wheels = null;
                    break;
            }
            if (_wheels != null) _wheels.setCountWheels(countWheels);
            additionalCollection.Insert(_wheels);
        }
    }
    @Override
    public void paint(Graphics g) {
        super.paint(g);
        if (_drawningTruck == null) return;
        Graphics e = pictureBox.getGraphics();
        e.setColor(pictureBox.getBackground());
        e.fillRect(0, 0, pictureBox.getWidth(), pictureBox.getHeight());
        _drawningTruck.DrawTransport(g);
    }
    public void SetCompany(AbstractCompany company) {
        _company = company;
    }
}
